# ==================================================================
# Plugins::Community::Tables - Auto Generated Program Module
#
#   Plugins::Community::Tables
#   Author  : Jonathan Gamble
#   Version : 2.0
#   Updated : Sat May 26 22:20:43 2007
#
# ==================================================================
#

package Plugins::Community::Tables;
# ==================================================================

    use strict;
    use GT::Base;
    use vars qw/$TCFG/;
    use GT::Plugins qw/STOP CONTINUE/;
    use Community qw/$CFG $IN $DB/;

    use Community::Web::Plugins;
    use IO::Dir;

	$TCFG = Community::Web::Plugins::get_plugin_user_cfg('Tables');

# Inherit from base class for debug and error methods
    @Plugins::Community::Tables::ISA = qw(GT::Base);

sub tables_admin {
# ---------------------------------------------------

# Process Tables Admin

	my $do = $IN->param('do') || '';

# Determine what to do

	return create_form() if ($do eq 'create_form');
	return create_table() if ($do eq 'create_table');
	return drop_table() if ($do eq 'drop_table');
	return adv_editor() if ($do eq 'adv_editor');

	use GT::SQL::Admin;

    my $admin = new GT::SQL::Admin;
    if ($admin->for_me($IN)) {
		print $IN->header;
        $admin->process(db => $DB, cgi => $IN);
		my $table = $IN->param('db');
    	print "<br><font face=arial size=2><a href=$CFG->{path_cgi_url}?do=admin_plugin&plugin=Tables&func=tables_menu>Return</a> | ";
		print "<a href=$CFG->{path_cgi_url}?do=admin_plugin&plugin=Tables&func=adv_editor&db=$table>Advanced Editor</a></font>";
		return;
    }
	return tables_menu();

}

sub tables_menu {
# ---------------------------------------------------

# Print Tables Menu



    my $defPath = $TCFG->{Path};


    my $template_set = $CFG->{system_template_set};

    my (@tables, %records);
    my $sb = $IN->param('sb') || '';
    my $so = $IN->param('so') || '';

    my $d = IO::Dir->new($defPath) || die "Could not open dirhandle! $!\n";

    my $pre = $DB->prefix();    # db prefix

    my $i = 0;

# get the table names

    while (defined(my $file = $d->read)) {

# Hide GT Tables
	
        if ($file ne '.' && $file ne '..' && $file ne 'database.def') {

	    $file =~ s/.def//;
            $file =~ s/$pre//;

            push(@tables, $file);     
        }
        $i++;
    }

# get the number of records for each table

    foreach (@tables) { 

        $records{$_} = $DB->table($_)->count() || '0';

    }

# go through each record and sort as needed

my $tables;
    
    foreach my $key (sort {

        if ($sb eq 'records') {
            return ($records{$b} cmp $records{$a}) if ($so eq 'DESC'); 
            return ($records{$a} cmp $records{$b});
        }
        else {
            return $b cmp $a if ($so eq 'DESC');
            return $a cmp $b;
        }

        } keys %records) {

            $CFG->{table_name} = $key;

            $CFG->{hits} = $records{$key};

            $tables .= GT::Template->parse($CFG->{path_private}.'/templates/'.$template_set.'/admin_tables_table.html', $CFG);

    }

# create tags opposite to the current sort

    if ($IN->param('so') eq 'ASC') {
        $TCFG->{so} = 'DESC';
    }
    else { $TCFG->{so} = 'ASC'; }

    $TCFG->{tables} = \$tables;


# print the template

	GT::Plugins->action (STOP);

	return ('admin_tables_menu.html', $TCFG);

}
sub create_form {
# ---------------------------------------------------

    my ($tags);
    my $template_set = $CFG->{system_template_set};

    $tags->{num_columns} = $IN->param('fields');
    $tags->{table_name} = $IN->param('tablename');

    print $IN->header;

    for (my $c = 1; $c <= $tags->{num_columns}; $c++) {

        $tags->{column} = $c;

        print GT::Template->parse($CFG->{path_private}.'/templates/'.$template_set.'/admin_tables_create.html', $tags);
						
    }

    
}

sub create_table {
#---------------------------------------------------
#

# create the table and the first field

	my $c = $DB->creator($IN->param('tablename'));

	my $i = 1;

	my @values1 = split(/\s+/, $IN->param('values1'));
	my @form_names1 = split(/\s+/, $IN->param('form_names1'));
		
	$c->cols($IN->param('column'.$i) => {
		pos => $i,
         	type => $IN->param('type'.$i),
                size => $IN->param('size'.$i),
		values => \@values1,
		not_null => $IN->param('not_null'.$i),
		default => $IN->param('default'.$i),
		form_display => $IN->param('form_display'.$i),
		form_type => $IN->param('form_type'.$i),
		form_size => $IN->param('form_size'.$i),
		form_names => \@form_names1,
		file_save_in => $IN->param('file_save_in'.$i),
		file_save_url => $IN->param('file_save_url'.$i),
		file_save_scheme => $IN->param('file_save_scheme'.$i),
		file_max_size => $IN->param('file_max_size'.$i),
		regex => $IN->param('regex'.$i)

	});

    $c->create or die "Unable to create: $GT::SQL::error";

# create the rest of the fields

	my $e = $DB->editor($IN->param('tablename'));

	for (my $i=2; $i <= $IN->param('fields'); $i++) {	

		my @values = split(/\s+/, $IN->param('values'.$i));
		my @form_names = split(/\s+/, $IN->param('form_names'.$i));

		$e->add_col($IN->param('column'.$i) => {
		pos => $i,
                type => $IN->param('type'.$i),
                size => $IN->param('size'.$i),
		values => \@values,
		not_null => $IN->param('not_null'.$i),
		default => $IN->param('default'.$i),
		form_display => $IN->param('form_display'.$i),
		form_type => $IN->param('form_type'.$i),
		form_size => $IN->param('form_size'.$i),
		form_names => \@form_names,
		file_save_in => $IN->param('file_save_in'.$i),
		file_save_url => $IN->param('file_save_url'.$i),
		file_save_scheme => $IN->param('file_save_scheme'.$i),
		file_max_size => $IN->param('file_max_size'.$i),
		regex => $IN->param('regex'.$i)

		}) or die "Unable to add column: $GT::SQL::error";

	}

	$TCFG->{message} = "The table " . $IN->param('tablename') . " was created successfully!";

        tables_menu();

}

sub drop_table {
#---------------------------------------------------
#

    if ($IN->param('drop_confirm') eq 'yes') {

	my $c = $DB->creator($IN->param('table_name'));
	
	$c->drop_table or die "Unable to drop: $GT::SQL::error";

        $TCFG->{message} = "The table " . $IN->param('table_name') . " was dropped successfully!";

        tables_menu();

    }

    elsif ($IN->param('drop_confirm') eq 'no') {

        $TCFG->{message} = "The table " . $IN->param('table_name') . " was NOT dropped!";

        tables_menu();

    }

    else {

        print $IN->header;

		GT::Plugins->action (STOP);

        return ('admin_tables_drop.html', $IN);

    }

}

sub adv_editor {
#---------------------------------------------------
#

	my $table = $IN->param('db');

	return if (!$table);

	# check for adding keys

	if ($IN->param('add_pk')) {
		my $e = $DB->editor($table);
		$e->add_pk($IN->param('add_pk')) or die "Unable to add primary key: $GT::SQL::error";
	}
	if ($IN->param('add_unique')) {
		my $e = $DB->editor($table);
		$e->add_unique($IN->param('add_unique') => [$IN->param('add_unique')]) or die "Unable to add unique key: $GT::SQL::error";
	}
	if ($IN->param('add_index')) {
		my $e = $DB->editor($table);
		$e->add_index($IN->param('add_index') => [$IN->param('add_index')]) or die "Unable to add index: $GT::SQL::error";
	}
	# get the table information
    use GT::Config;

	my $template_set = $CFG->{system_template_set};
    my $pre = $DB->prefix(); # db prefix
    my $tb = GT::Config->load($CFG->{path_private}."/defs/".$pre.$table."\.def");
	# protect columns from editing   
    if ($IN->param('allow')) {
		$tb->{cols}->{$IN->param('allow')}->{protect} = undef;
		$tb->save;
	}
	if ($IN->param('protect')) {
		$tb->{cols}->{$IN->param('protect')}->{protect} = 1;
		$tb->save;
	}
	if ($IN->param('add_ai')) {
		my $sth = $DB->table($table);
		$sth->do("ALTER TABLE ".$table." CHANGE ".$IN->param('add_ai')." ".$IN->param('add_ai')." INT NULL AUTO_INCREMENT") or die $GT::SQL::error;
		$tb->{ai} = $IN->param('add_ai');
		$tb->save;
	}
	if ($IN->param('drop_ai')) {
		my $sth = $DB->table($table);
		$sth->do("ALTER TABLE ".$table." CHANGE ".$IN->param('drop_ai')." ".$IN->param('drop_ai')." INT") or die $GT::SQL::error;
		$tb->{ai} = undef;
		$tb->save;
	}	
	# check for dropping keys

	if ($IN->param('drop_pk')) {
		my $e = $DB->editor($table);
		$e->drop_pk or die "Unable to drop primary key: $GT::SQL::error";
		$tb->{pk} = []; # take care of editor.pm bug with drop_pk
		$tb->save;
	}
	if ($IN->param('drop_unique')) {
		my $e = $DB->editor($table);
		$e->drop_unique($IN->param('drop_unique')) or die "Unable to drop unique key: $GT::SQL::error";
	}
	if ($IN->param('drop_index')) {
		my $e = $DB->editor($table);
		$e->drop_index($IN->param('drop_index')) or die "Unable to drop index: $GT::SQL::error";
	}
	my @pks = @{$tb->{pk}};

	# change the position if necessary

	if ($IN->param('up') && $IN->param('down')) {

		my $up = $tb->{cols}->{$IN->param('up')}->{pos};
		my $down = $tb->{cols}->{$IN->param('down')}->{pos};

		$tb->{cols}->{$IN->param('up')}->{pos} = $down;
		$tb->{cols}->{$IN->param('down')}->{pos} = $up;		

		$tb->save;
	}
	# get indexes

	my @columns = keys %{$tb->{cols}};
	my @uniques = keys %{$tb->{unique}};
	my @indexes = keys %{$tb->{index}};

	# put the positions in an array

	my %pos;
	foreach (@columns) {
		$pos{$_} = $tb->{cols}->{$_}->{pos};
	}
	# sort by position

	my $c = 0;

	my @pos = sort {$pos{$a} cmp $pos{$b}} keys %pos;
	
	my $cols;

	foreach my $key (@pos) {

	# get the columns of interests

		if ($c == 0) {
			$CFG->{first} = 1;
		}
		else {
			$CFG->{before} = $pos[$c-1];
		}
		if ($c == scalar(@columns)-1) {
			$CFG->{last} = 1;
		}
		else {
			$CFG->{after} = $pos[$c+1];
		}
		# sort out indexes
		foreach (@pks) {
			if ($_ eq $key) {
				$CFG->{pk} = $key;
			}
		}
		foreach (@uniques) {
			if ($_ eq $key) {
				$CFG->{unique} = $key;
			}
		}
		foreach (@indexes) {
			if ($_ eq $key) {
				$CFG->{index} = $key;
			}
		}
		if ($key eq $tb->{ai}) {
			$CFG->{ai} = $key;
		}
		if ($tb->{cols}->{$key}->{protect}) {
			$CFG->{protect} = 1;
		}
		$CFG->{column} = $key;
		$CFG->{table} = $table;
		
 		$cols .= GT::Template->parse($CFG->{path_private}.'/templates/'.$template_set.'/admin_tables_adv_table.html', $CFG);
		# reset to null for template
		$CFG->{first} = undef;
		$CFG->{pk} = undef;
		$CFG->{unique} = undef;
		$CFG->{index} = undef;
                                $CFG->{protect} = undef;
		$c++;
	}

# print the template

	$TCFG->{columns} = \$cols;
	$TCFG->{table} = $table;

	GT::Plugins->action (STOP);

	return ('admin_tables_adv.html', $TCFG);

}


# Always end with a 1.
1;